#include "colors.inc"

global_settings {max_trace_level 10}
#declare outer_globe = sphere { 
	<0,0,0> 2
}

#declare inner_globe = sphere {
	<0,0,0>, 1.9
}

#declare globe = difference { 
	object { outer_globe }
	object {inner_globe }
}

#declare base = difference {
	union {
		cylinder { <0,0,0> , <0,0.25,0> 1.25 }
		cylinder { <0,0.25,0> , <0,0.5,0> 1.125 }
		cylinder { <0,0.5,0> , <0,0.75,0> 1 }
	}
	object { outer_globe translate <0,2.5,0> }
}

#ifdef (SIMPLE_TEXTURE)
#declare glass = texture { pigment { Blue } }
#declare water = finish {  diffuse 0.6}
#declare base_texture = texture { pigment { White } }
#declare snow = texture { pigment { White  } }
#else
#declare glass = texture {
finish {
        ambient 0.1
        diffuse 0.1
        reflection 0.07
        specular 0.8
        roughness 0.01
     }
     pigment { rgbf <1,1,1,1> }
}

#declare water = finish {
        ambient 0.1
        diffuse 0.11
	diffuse 0.1
}

#declare base_texture = texture {
	pigment {
		marble 
		color_map {
			[ 0 color White ]
			[ 0.80 color <0.9,0.9,0.9> ]
			[ 0.80 rgb <0.2,0.2,0.2> ]
			[ 0.97 color rgb <0,0,0> ]
			[ 0.97 color rgb <0.33,0.28,0.04> ]
			[ 1 color rgb <0.41,0.36,0.05> ]
		}
		turbulence <0.8, 0.7,0.5>
		rotate <0,0,15>
		scale 0.4
	}
	finish {
		diffuse 0.6
		brilliance 0.6
		specular 0.7
		roughness 0.1
	}
}
texture {
	pigment {
		marble 
		color_map {
			[ 0 color rgbt<0,0,0,1>]
			[ 0.85 color rgbt<0,0,0,1>]
			[ 0.85 color rgb <0.25,0.15,0.15> ]
			[ 1 rgb <0.5,0.1,0.1> ]
		}
		turbulence <0.6, 0.2,0.5>
		rotate <0,-25,0>
		scale 0.1
	}
}
texture {
	pigment {
		crackle
		color_map {
			[ 0 color rgbt<0,0,0,1>]
			[ 0.40 color rgbt<0,0,0,1>]
			[ 0.40 color rgb <0.40,0.15,0.15> ]
			[ 1 rgb <0.2,0.05,0.05> ]
		}
		scale 0.25
	}
}


#declare snow = texture {
    bozo 
    texture_map {
	[ 0 pigment { rgbt < 0.98, 0.98,0.98,1> } ]
	[ 0.75 pigment { rgbt < 0.98, 0.98,0.98,1> } ]
	[ 0.75 finish { diffuse 0.9 } pigment { White } ]
	[  1 finish { diffuse 0.9 } pigment { White } ]
    }
	scale 0.02
	turbulence 0.8	
}

#end

#declare contents = difference { 
	object { 
		inner_globe 
	}
	object { 
		inside_notex
		translate <0,-1,0>
	} 
	interior { ior 1.33 } 
	texture { 
		finish { water } 
		pigment { rgbt < 0.98, 0.98,0.98,1> }
	}
	scale 0.98
}

#declare inside_draw = intersection {
	object {
		inside
		translate <0,-1,0>
	}
	object { inner_globe }
}


