#declare tree_spiral = texture {
	pigment {
		spiral1 1
		color_map {
			[0 color rgb <1,0,0> ]
			[0.5 color Yellow rgb <1,1,0> ]
			[1.0 color Blue  rgb <0,0,1> ]
		}
		rotate <90,0,0>
	}
	finish { ambient 1.0 }
}

#declare tree_outer = texture {
	pigment {
		leopard
		color_map {
			[0 color rgbf <0,0.5,0,0> ]
			[0.65 color rgbf <0,0.5,0,0> ]
			[0.65 color rgbf <1,1,1,1> ]
			[1 color rgbf <1,1,1,1> ]
		}
	}
	scale 0.025
}
#declare star_tex = texture {
	pigment { Yellow }
	finish { ambient 0.5}
}

#declare p1_tex = texture {
	pigment {
		gradient x
		color_map {
			[0 color Green ]
			[0.25 color Green ]
			[0.25 color Red ]
			[1 color Red ]
		}
	}
}

#declare p2_tex = texture {
	pigment {
		gradient x
		color_map {
			[0 rgb <0,1,1> ]
			[0.25 rgb <0,1,1> ]
			[0.25 rgb <1,0,0> ]
			[1 rgb <1,0,0> ]
		}
	}
}

#declare p3_tex = texture {
	pigment {
		gradient x
		color_map {
			[0 rgb <0,1,1> ]
			[0.25 rgb <0,1,1> ]
			[0.25 rgb <0,0,1> ]
			[1 rgb <0,0,1> ]
		}
	}
}

#declare snow_tex = texture {
	pigment { White }
	normal { 
		bumps 0.25 
		scale 0.5
	}
	finish {
		specular 0.8
		roughness 0.25
	}
}


#declare tree = cone {
	<0,1.5,0>, 0.0, <0,0,0>,0.5
}

#declare starc = cone {
	<0,0,0>, 0.05, <0,0.125,0> 0
}

#declare sub_star=union {
	object { starc }
	object { starc rotate <0,0,90> }
	object { starc rotate <0,0,180> }
	object { starc rotate <0,0,270> }
}

#declare star = union {
	object { sub_star }
	object { sub_star scale 0.85 rotate <0,0,45> }
}

#declare present = box {
	<0.5,0.5,0.5>, <-0.5,-0.5,-0.5>
}

#declare inside = union {
object {
	tree
	texture { tree_spiral }
	scale 0.999
	translate <0,0.25,0>
}


object {
	tree
	texture { tree_outer }
	translate <0,0.25,0>
}

cylinder {
	<0,0,0>, <0,0.25,0>, 0.125
	pigment { Brown }
}


object {
	star
	texture { star_tex }
	translate <0,1.875,0>
}

object { 
	present
	texture {p1_tex }
	rotate <0,45,0>
	scale 0.125
	translate <-0.5,0.0675,-0.5>
}

object { 
	present
	texture {p2_tex }
	rotate <0,75,0>
	scale 0.125
	translate <0.5,0.0675,-0.5>
}

object { 
	present
	texture {p3_tex }
	rotate <0,75,0>
	scale 0.125
	translate <0,0.0675,0.5>
}

box {
	<-5,0,-5>,<5,-5,5>
	texture {snow_tex }
}
}

#declare inside_notex = union {
object {
	tree
	translate <0,0.25,0>
}

cylinder {
	<0,0,0>, <0,0.25,0>, 0.125
}


object {
	star
	translate <0,1.875,0>
}

object { 
	present
	rotate <0,45,0>
	scale 0.125
	translate <-0.5,0.0675,-0.5>
}

object { 
	present
	rotate <0,75,0>
	scale 0.125
	translate <0.5,0.0675,-0.5>
}

object { 
	present
	rotate <0,75,0>
	scale 0.125
	translate <0,0.0675,0.5>
}

box {
	<-5,0,-5>,<5,-5,5>
}
}
