#include "colors.inc"

#declare TreeScale = < 0.1, 0.1, 1>;
#declare TreeTexture = texture {
	pigment { 
		bozo 
		color_map {
			[ 0 Brown ]
			[ 0.65 DarkBrown ]
			[ 1 Black ]
		}
		scale TreeScale
	}
	normal {
		bozo 
		slope_map {
			[ 0 <-0.5, 0> ]
			[ 0.65 <0,-1> ]
			[ 1 <-0.5, 0> ]
		}
		scale TreeScale
	}
	finish {
		diffuse 0.5
	}
}
#declare NeedleTexture = texture {
	pigment { 
		gradient x
		color_map {
			[0 ForestGreen ]
			[0.08 ForestGreen ]
			[0.08 Clear ]
			[1.0 Clear ]
		}
	}
	finish {
		diffuse 0.35
		phong 0.4
		phong_size 105
	}
	normal {
		gradient x
		slope_map {
			[0 <0.5, 0> ]
			[0.01 <0,20> ]
			[0.01 <0,0> ]
			[0.1 <0,0> ]
		}
	}
}

#declare BulbFinish = finish {
	diffuse 0.4
	phong 0.9
	phong_size 235
	reflection 0.84
}

#declare BulbBlue = pigment { rgb< 0.1, 0.0, 0.65> }
#declare BulbRed = pigment { rgb< 0.65, 0.0, 0.1> }
#declare BulbYellow = pigment { rgb< 0.70, 0.70, 0.0> }

#declare ShinyFinish = 	finish {
		diffuse 0.45
		phong 0.9
		phong_size 175
		metallic
		reflection 0.9
	}

#declare HookTexture = texture {
	pigment { Silver }
	finish { ShinyFinish }
}

#declare CapTexture = texture {
	pigment { Silver }
	finish { ShinyFinish }
	normal { 
		radial
		frequency 10
		slope_map {
			[0 <0,0>]
			[0.35 <0, 0>]
			[0.35 <0, 1>]
			[0.5 <-1,0> ]
			[0.65 <0,-1> ]
			[0.65 <0,0> ]
			[1.0 <0,0> ]
		}
	}
}
#macro bulb(bc, bx, by, bz) 
union {
	sphere {
		<0,-2,0>, 1
		texture { 
			pigment { bc }
			finish { BulbFinish }
		}
	}
	cone {
		<0,-1.1,0>, 0.2, <0,-0.8,0>, 0.1
		texture { 
			pigment { bc }
			finish { BulbFinish }
		}
	}
	cylinder {
		<0,-0.75,0>, <0,-0.85,0> 0.2
		texture { CapTexture }
	}
	torus { 
		0.1, 0.025
		rotate <90,0,0>
		translate <0,-0.675,0>
		texture { HookTexture }
	}
	torus { 
		0.1, 0.025
		rotate <90,0,0>
		rotate <0,90,0>
		translate <0,-0.525,0>
		texture { HookTexture }
	}
	cylinder {
		<0,-0.425,0>, <0,0,0>, 0.025
		texture { HookTexture }
	}
	translate <bx, by, bz>
}
#end

#include "tree.out.pov"
#include "bulb.out.pov"

#include "xmas.pov"

camera {
        location <0,9,-7.5>
        look_at <0,0,-48> 
}

